// iniciado em 30.03.2007 - Matias
// Funo que coloca dimensoes externas do modelo ativo em ordem crescente no 
// parametro caixa_minima. Se parametro ainda no existe, cria o parametro.

import com.ptc.cipjava.*;
import com.ptc.pfc.pfcSession.*;
import com.ptc.pfc.pfcBase.*;
import com.ptc.pfc.pfcModel.*;
import com.ptc.pfc.pfcSolid.*;
import com.ptc.pfc.pfcFeature.*;
import com.ptc.pfc.pfcExceptions.*;
import com.ptc.pfc.pfcAssembly.*;
import com.ptc.pfc.pfcModelItem.*;


public class PfcColocaDimensoes{

  private Session proeSession;
  private Model modelo;
  private String nomeArq;
  private Features listaComponentes;
  private int qtdeComponentes;
  private Assembly conjunto;
  private Parameter parametro;
  private String valorParametro;
  private ComponentPath[] arvore;
  private int tamanhoArvore;
  private String textoApresentacao;
    
  public PfcColocaDimensoes(Session inSession) 
                                     throws com.ptc.cipjava.jxthrowable {
    
    proeSession=inSession;
    Model modelo = proeSession.GetCurrentModel(); 
    
    if (modelo == null || (modelo.GetType() != ModelType.MDL_PART && 
	                       modelo.GetType() != ModelType.MDL_ASSEMBLY)) {
         StartColocaDimensoes.printMsg ("no  parte ou conjunto, tchau ento...");
         throw new RuntimeException ("No  parte ou conjunto. Abortando...");
    }
    Model modeloAux;
    modeloAux = modelo;
	Solid solido;
    solido = (Solid)modelo;
    String outline;
	Outline3D boundBox;
	Point3D a, b;
    Parameter p;
	ParamValue pv;
	ParamValue pa;
	String teste;

	int[] dim = new int[3];
	boundBox = solido.GetGeomOutline();
	a = boundBox.get(0); b = boundBox.get(1);
	dim[0] = (int)(Math.ceil(b.get(0)-a.get(0)));
	dim[1] = (int)(Math.ceil(b.get(1)-a.get(1)));
    dim[2] = (int)(Math.ceil(b.get(2)-a.get(2)));
	java.util.Arrays.sort(dim);
	outline = (dim[2] + " x " + dim[1] +" x "+ dim[0]);
    //StartColocaDimensoes.printMsg ("cheguei ate aqui");
    //apresenta resultados
    //StartColocaDimensoes.printMsg (outline);

	//parte de criar e preencher parametro caixa_minima
	p = modeloAux.GetParam("CAIXA_MINIMA");
	pv = pfcModelItem.CreateStringParamValue("");
	if (p == null) {
		p = modeloAux.CreateParam("CAIXA_MINIMA", pv);
	} 
	teste = p.GetValue().GetStringValue();
	if (!(teste.equals(outline))) {
		pv = pfcModelItem.CreateStringParamValue(outline);
		p.SetValue(pv);
	}
    StartColocaDimensoes.printMsg 
	           ("Parmetro CAIXA_MINIMA criado e/ou atualizado com: "+outline);
	}
}

    

    
	    
	    
    
    
    


